﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Core;

namespace AnonymousInterfaces
{
    public interface ISampleInterface
    {
        int DoSomething(int a, string b);
        string DoSomethingElse(bool b);
    }

    class Program
    {
        static void Main(string[] args)
        {
            //contrived
            ISampleInterface sample = Make.Instance<ISampleInterface>(
                                        new {
                                            DoSomething = Make.Func(
                                                (int a, string b) => 
                                                { 
                                                    Console.WriteLine("Doing Something");
                                                    return a + b.Length;
                                                }),
                                            DoSomethingElse = Make.Func(
                                            (bool b) =>
                                                {
                                                    Console.WriteLine("Doing Something Else");
                                                    return b.ToString();
                                                })
                                        });

            int result = sample.DoSomething(5, "abc");
            Console.WriteLine("Returned " + result);

            string result2 = sample.DoSomethingElse(true);
            Console.WriteLine("Returned " + result2);

            //less contrived
            List<string> items = new List<string> { "a", "aa", "aaa", "aaaa", "aaaaa" };
            string stringToFind = "bbb";

            //equality comparer that looks for things of the same length
            bool containsLength3 = items.Contains(stringToFind,
                Make.Instance<IEqualityComparer<string>>(
                    new {
                        Equals = Make.Func((string x, string y) => x.Length == y.Length)
                    }));

            Console.WriteLine("Contains other string with length 3? " + containsLength3);

            Console.ReadLine();
        }
    }
}
