﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;

namespace Core
{
    //wrapper for anon type to allow easy dictionary-like access
    public class Record
    {
        public Record(object o)
        {
            _inner = o;
        }

        private object _inner;
        private IDictionary<string, object> _properties;

        private void EnsureProperties()
        {
            if (_properties == null)
            {
                _properties = new Dictionary<string, object>();
                foreach (PropertyInfo p in _inner.GetType().GetProperties())
                {
                    _properties.Add(p.Name, p.GetValue(_inner, null));
                }
            }
        }

        public object this[string propertyName]
        {
            get
            {
                EnsureProperties();

                return _properties[propertyName];
            }
        }

        public T Get<T>(string propertyName)
        {
            return (T)this[propertyName];
        }

        public bool ContainsProperty(string propertyName)
        {
            EnsureProperties();

            return _properties.ContainsKey(propertyName);
        }
    }
}
